# Roadmap

This document describes the developement plan for Rox.

## High priority tasks

1. Support basic sequential components, basically registers and
   synchronous memory that can be inferred into BRAMs.

2. Support more advanced sequential constructs, mainly FSMs.

3. Support automatic pipeline generation.

## Lower priority tasks

1. Do not bail out on the first error, but try to generate more error
   messages.
   
2. Write a test suite.

3. Support functions that do not generate VHDL components.

4. Support bidirectional ports.

5. Implement floating-point functions that can be used in constant
   folding.

## Implemented features that should be tested better

1. Generate VHDL code for basic combinational components, handling
   such operations as bitwise manipulation, addition and multiplexing.

2. Basic constant folding.
